package syncloud.dao.sqljet;

import org.tmatesoft.sqljet.core.SqlJetException;
import org.tmatesoft.sqljet.core.SqlJetTransactionMode;
import org.tmatesoft.sqljet.core.table.SqlJetDb;

import java.io.File;

public class Database {

    private static SqlJetDb db;
    private String dbPath;

    public Database(String dbPath) {
        this.dbPath = dbPath;
    }

    public SqlJetDb open() {
        try {
            File dbFile = new File(dbPath);

            boolean noStructure = !dbFile.exists();

            SqlJetDb db = SqlJetDb.open(dbFile, true);

            if (noStructure) {
                createStructure(db);
            }
            return db;
        } catch (Exception exception) {

        }
        return null;
    }

    private void createStructure(SqlJetDb db) throws SqlJetException {
        db.beginTransaction(SqlJetTransactionMode.WRITE);
        try {
            db.createTable("CREATE TABLE states (full_name TEXT NOT NULL PRIMARY KEY, version TEXT NULL)");
            db.createIndex("CREATE INDEX full_name_index ON states(full_name)");
        } finally {
            db.commit();
        }
    }

}
